% Part I of Task III
% Testing Multigrid on the Poisson equation w\ discrete Laplacian
% Dependence of no. of iterations on system size
fprintf(stdout,'*** Task III: Multigrid ***\n\n');

%%%
fprintf (stdout,'\nPush a button to continue with part I\n');
fprintf (stdout,'Dependence on system size\n');
pause
clear all
%%%


for i=1:5,
   N(i)=2^(i+2)-1;
   b = 1/N(i)^2*ones(N(i),N(i));

   fprintf(stdout,'no. of inner grid points in one dimension: %d\n',N(i));
   fflush(stdout);

   [sol iter(i)] = multi_grid( b, 2 ,0);

   %plot solution
   figure(1)
   X = reshape(sol,N(i),N(i));
   mesh(X)
   title('solution')

   pause(1)
end

figure(2)
plot(N,iter,'+-r');
legend('Multigrid');
xlabel('N');
ylabel('iterations');

%%%
fprintf (stdout,'\nPush a button to continue with error for Multigrid\n');
pause
clear all
%%%

fprintf(stdout,'no. of inner grid points in one dimension: 63\n');
b = 1/63^2*ones(63);
fflush(stdout);
multi_grid( b, 4 ,3);


%%%
fprintf (stdout,'\nPush a button to continue with part II\n');
fprintf (stdout,'Multigrid as a preconditioner to GMRES\n');
pause
clear all
%%%

A=laplace(63);
b=ones(63^2,1);

resvec = cell(3,1);
restart = [100 10];

[x,relres,iter,resvec{1},H] = gmres(@(x)Laplace_mult2(x,A,@(x)x),b,restart(1),10^(-10),(ceil(500/restart(1))));
[x,relres,iter,resvec{2},H] = gmres(@(x)Laplace_mult2(x,A,@(x)multi_grid_preconditioner(x,2,1)),b,restart(2),10^(-10),(ceil(500/restart(2))));
%[x,relres,iter,resvec{2},H] = fgmres(A,@(x)multi_grid_preconditioner(x,2,1),b,restart,10^(-10),(ceil(500/restart)));

b = 1/63^2*ones(63);
[sol,iter,resvec{3}]=multi_grid( b, 2 ,0);

figure(3)
semilogy(0:restart(1):(length(resvec{1})-1)*restart(1),resvec{1},'-x','MarkerSize',2,...
         0:restart(2):(length(resvec{2})-1)*restart(2),resvec{2},'-x','MarkerSize',2,...
         0:(length(resvec{3})-1),resvec{3},'-x','MarkerSize',2);
axis([0 210 10^(-11) 100]);
xlabel('iterations')
legend('GMRES(100)','preconditioned GMRES(10)','stand alone multigrid')
title('discrete Laplacian 63x63 on grid')
box off;
grid on;

%%%
fprintf (stdout,'\nPush a button to finish Task III\n\n');
pause
clear all
close all
%%%
